#pragma once

#include <gl/gl.h>
#include <gl\glu.h>
#include "TScene.h"


class EngineVR
{
public:
	TScene       * SceneList; //Available Scenes
    unsigned int SceneListLen; //Number of Scenes
    unsigned     CurrentScene;//Selected Scene

	unsigned int ViewPortWidth;
	unsigned int ViewPortHeight;
    
	EngineVR(void);
	~EngineVR(void);
	
	int  CreateSceneView(HWND Wnd,int Width, int Height,int DepthBufferBits, int ColorBufferBits);
	void ResizeSceneView(unsigned int width, unsigned int height);
	void KillSceneView();

	void InitEngineVR();  //Initializes selected Scene
	void BuildSceneGeometry();
    void RenderScene();   //draw scene
	void RenderScene(unsigned int Scene);//draw scene
	void RenderToTexture(TTexture * t);
	void ClearBuffers();
	void ClearBuffers(int cb, int db);
	void FlipBuffers();
	void BuildSceneMatrices();
	void CreateSet(unsigned int NumberOfScenes);  
	void DestroySet();
};

