#include "StdAfx.h"
#include "TCamera.h"


void TCamera::BuildMatrix()
{
	glMatrixMode(GL_MODELVIEW);               // select the modelviewmode transformation of the entities
	glLoadIdentity();                         // loads the identity matrix
	glRotatef     (-Pose.roll ,0.0f,0.0f,1.0f);// rotation around Z axis
	glRotatef     (-Pose.pitch,1.0f,0.0f,0.0f);// rotation around X axis
	glRotatef     (-Pose.yaw  ,0.0f,1.0f,0.0f);// rotation around Y axis
	glTranslatef  ( Pose.x,-Pose.y,Pose.z);      // translate the camera to the desired position
	glGetFloatv   (GL_MODELVIEW_MATRIX ,TR.m);
}

void TCamera::Translate(float x, float y, float z)
{
	Pose.vector(x,y,z);
}

void TCamera::Rotate   (float roll, float pitch, float yaw)
{
	Pose.roll  = roll;
	Pose.pitch = pitch;
	Pose.yaw   = yaw;
}