
// TEngineVRDemo1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TEngineVRDemo1.h"
#include "TEngineVRDemo1Dlg.h"
#include "afxdialogex.h"

#include "EngineVR.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTEngineVRDemo1Dlg dialog

EngineVR VR;


CTEngineVRDemo1Dlg::CTEngineVRDemo1Dlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTEngineVRDemo1Dlg::IDD, pParent)
	, Log(_T(""))
	, Shading(0)
	, Mapping(0)
	, Texture(0)
	, MappingType(0)
	, Level(0)
	, EnvMode(0)
	, BlendSRC(0)
	, BlendDST(0)
	, Blend(0)
	, EnableBkgT(FALSE)
	, EnableLev(0)
	, R2T(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTEngineVRDemo1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, Log);
	DDX_CBIndex(pDX, IDC_COMBO1, Shading);
	DDX_CBIndex(pDX, IDC_COMBO2, Mapping);
	DDX_CBIndex(pDX, IDC_COMBO3, Texture);
	DDX_CBIndex(pDX, IDC_COMBO4, MappingType);
	DDX_CBIndex(pDX, IDC_COMBO5, Level);
	DDX_CBIndex(pDX, IDC_COMBO6, EnvMode);
	DDX_CBIndex(pDX, IDC_COMBO7, BlendSRC);
	DDX_CBIndex(pDX, IDC_COMBO8, BlendDST);
	DDX_CBIndex(pDX, IDC_COMBO9, Blend);
	DDX_Check(pDX, IDC_CHECK1, EnableBkgT);
	DDX_CBIndex(pDX, IDC_COMBO10, EnableLev);
	DDX_Check(pDX, IDC_CHECK2, R2T);
}

BEGIN_MESSAGE_MAP(CTEngineVRDemo1Dlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO1, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo1)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo2)
	ON_CBN_SELCHANGE(IDC_COMBO3, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo3)
	ON_CBN_SELCHANGE(IDC_COMBO4, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo4)
	ON_CBN_SELCHANGE(IDC_COMBO5, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo5)
	ON_CBN_SELCHANGE(IDC_COMBO6, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo6)
	ON_CBN_SELCHANGE(IDC_COMBO7, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo7)
	ON_CBN_SELCHANGE(IDC_COMBO8, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo8)
	ON_CBN_SELCHANGE(IDC_COMBO9, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo9)
	ON_BN_CLICKED(IDC_CHECK1, &CTEngineVRDemo1Dlg::OnBnClickedCheck1)
	ON_CBN_SELCHANGE(IDC_COMBO10, &CTEngineVRDemo1Dlg::OnCbnSelchangeCombo10)
	ON_BN_CLICKED(IDC_CHECK2, &CTEngineVRDemo1Dlg::OnBnClickedCheck2)
END_MESSAGE_MAP()


// CTEngineVRDemo1Dlg message handlers

BOOL CTEngineVRDemo1Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CRect rect;
	GetDlgItem(IDC_VIEW)->GetWindowRect(&rect);
	VR.CreateSceneView(GetDlgItem(IDC_VIEW)->m_hWnd,rect.Width(), rect.Height(),16, 32);

	VR.InitEngineVR();
	

	VR.CreateSet(1);
	VR.SceneList[0].CreateScene(1,1,1);
	VR.SceneList[0].ClearColor.r=1.0f;
	VR.SceneList[0].ClearColor.g=1.0f;
	VR.SceneList[0].ClearColor.b=1.0f;
	VR.SceneList[0].ClearColor.a=1.0f;
	VR.SceneList[0].Background.LoadBMPTexture("textures/Background2.bmp",TXMIPMAP);
	//VR.SceneList[0].OList[0].CreateSampleCube();
	VR.SceneList[0].ObjectList[0].LoadOBJObject("Models/Boxes.obj");
	//VR.SceneList[0].ObjectList[0].Scale.vector(0.15,0.15,0.15);
	VR.SceneList[0].ObjectList[0].Scale.vector(0.35,0.35,0.35);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture0.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture1.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture2.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture3.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture4.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture5.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture6.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture7.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture8.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture9.bmp",TXMIPMAP);
	VR.SceneList[0].ObjectList[0].AddTexture("textures/Texture10.bmp",TXMIPMAP);
	//adding texture levels
	VR.SceneList[0].ObjectList[0].MaterialList[0].AddTextureLevel(0,0);
	
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[0].Visible=1;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[0].TextureIndex=0;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[0].MappingType=0;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[0].EnvMode=TX_MODE_MODULATE;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[0].Blend=0;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[0].BlendSrc=TX_BLEND_ZERO;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[0].BlendDst=TX_BLEND_ZERO;

	VR.SceneList[0].ObjectList[0].MaterialList[0].AddTextureLevel(0,0);
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[1].Visible=0;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[1].TextureIndex=7;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[1].MappingType=1;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[1].EnvMode=TX_MODE_MODULATE;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[1].Blend=1;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[1].BlendSrc=TX_BLEND_SRC_COLOR;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[1].BlendDst=TX_BLEND_ONE_MINUS_SRC_COLOR;

	VR.SceneList[0].ObjectList[0].MaterialList[0].AddTextureLevel(0,0);
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[2].Visible=0;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[2].TextureIndex=7;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[2].MappingType=1;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[2].EnvMode=TX_MODE_MODULATE;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[2].Blend=1;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[2].BlendSrc=TX_BLEND_SRC_COLOR;
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[2].BlendDst=TX_BLEND_ONE_MINUS_SRC_COLOR;

	VR.SceneList[0].LightList[0].SetPosition(0.0f, 10.0f, 10.0f);
	VR.SceneList[0].LightList[0].LookAt     (0.0f,  0.0f,  0.0f);
	VR.SceneList[0].LightList[0].LoadLight();
	//VR.BuildSceneGeometry();
	Log.Format("Number of Scenes %d\r\n",VR.SceneListLen);
	Log.AppendFormat("Number of Cameras %d\r\n",VR.SceneList[0].CameraListLen);
	Log.AppendFormat("Number of Lights %d\r\n",VR.SceneList[0].LightListLen);
	Log.AppendFormat("Number of Objects %d\r\n",VR.SceneList[0].ObjectListLen);
	Log.AppendFormat("Number of Surfaces %d\r\n",VR.SceneList[0].ObjectList[0].SurfaceListLen);
	Log.AppendFormat("Number of Polygons %d\r\n",VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonListLen);
	Log.AppendFormat("Number of Vertices %d\r\n",VR.SceneList[0].ObjectList[0].SurfaceList[0].VNListLen);
	Log.AppendFormat("Number of TexCoords %d\r\n",VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordListLen);
	Log.AppendFormat("Number of Materials %d\r\n",VR.SceneList[0].ObjectList[0].MaterialListLen);
	Log.AppendFormat("Number of TxLevels %d\r\n",VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelListLen);
	Log.AppendFormat("Number of textures %d\r\n",VR.SceneList[0].ObjectList[0].TextureListLen);
		
	
	UpdateData(FALSE);

	SetTimer(IDC_TIMER,40,0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTEngineVRDemo1Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTEngineVRDemo1Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

float t=0;

void CTEngineVRDemo1Dlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	VR.ClearBuffers(1,1);
	VR.SceneList[0].CameraList[0].Pose.SetPose(  0.0f, 
		                                    4.0f, 
									       10.0f,
									        0.0f,
									      -10.0f,
									      180.0f);
	VR.SceneList[VR.CurrentScene].ObjectList[0].Pose.SetPose(0,-1,0,0,0,t);
	VR.BuildSceneMatrices();
	if(R2T) VR.RenderToTexture(&VR.SceneList[VR.CurrentScene].ObjectList[0].TextureList[10]);
	VR.RenderScene();
	VR.FlipBuffers();
	t++;
	CString Str;
	Str.Format("%.3f",t);
	this->SetWindowTextA(Str);

	
	CDialogEx::OnTimer(nIDEvent);
}


void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo1()
{
	UpdateData(TRUE);
	VR.SceneList[VR.CurrentScene].ObjectList[0].MaterialList[0].Smoothing = Shading;
}

float CalcPolarCoordinate(float x,float z)
{
 float dist = sqrt(x*x+z*z);
 float a = (float)acos((float)z/dist)/PI;
 if(x>=0) return a;
 return 360-a;
}


void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo2()
{
	int i;
	UpdateData(TRUE);
	switch(Mapping)
	{
		//Planar XY
	case 0:for(i=0;i<VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonListLen;i++)
		   {
			   VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].t0].u = 
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].x-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.x)/
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Max.x-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.x);

			   VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].t0].v = 
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].y-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.y)/
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Max.y-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.y);
		   }
		   break;

		//Planar ZY
	case 1:for(i=0;i<VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonListLen;i++)
		   {
			   VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].t0].u = 
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].z-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.z)/
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Max.z-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.z);

			   VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].t0].v = 
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].y-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.y)/
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Max.y-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.y);
		   }
		   break;

		//Planar XZ
	case 2:for(i=0;i<VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonListLen;i++)
		   {
			   VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].t0].u = 
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].x-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.x)/
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Max.x-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.x);

			   VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].t0].v = 
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].z-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.z)/
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Max.z-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.z);
		   }break;

		//Cylindrical Y
	case 3:for(i=0;i<VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonListLen;i++)
		   {
			   VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].t0].u = 
			   CalcPolarCoordinate(VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].x,VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].z);

			   VR.SceneList[0].ObjectList[0].SurfaceList[0].TexCoordList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].t0].v = 
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].VertexList[VR.SceneList[0].ObjectList[0].SurfaceList[0].PolygonList[i].v0].y-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.y)/
			   (VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Max.y-VR.SceneList[0].ObjectList[0].SurfaceList[0].BBox.Min.y);
		   }
		
		break;
	}
}


void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo3()
{
	UpdateData(TRUE);
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].TextureIndex = Texture;
}


void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo4()
{
	UpdateData(TRUE);
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].MappingType = MappingType;
}


void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo5()
{
	UpdateData(TRUE);
	Texture     = VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].TextureIndex;
	MappingType = VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].MappingType;
	switch(VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].EnvMode)
	{
	case TX_MODE_ADD     : EnvMode=0; break;
	case TX_MODE_MODULATE: EnvMode=1; break;
	case TX_MODE_DECAL   : EnvMode=2; break;
	case TX_MODE_BLEND   : EnvMode=3; break;
	case TX_MODE_REPLACE : EnvMode=4; break;
	}

	switch(VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc)
	{
	case  TX_BLEND_ZERO               :BlendSRC=0;break;
	case  TX_BLEND_ONE                :BlendSRC=1;break;
	case  TX_BLEND_SRC_COLOR          :BlendSRC=2;break;
	case  TX_BLEND_ONE_MINUS_SRC_COLOR:BlendSRC=3;break;
	case  TX_BLEND_DST_COLOR          :BlendSRC=4;break;
	case  TX_BLEND_ONE_MINUS_DST_COLOR:BlendSRC=5;break;
	case  TX_BLEND_SRC_ALPHA          :BlendSRC=6;break;
	case  TX_BLEND_ONE_MINUS_SRC_ALPHA:BlendSRC=7;break;
	case  TX_BLEND_DST_ALPHA          :BlendSRC=8;break;
	case  TX_BLEND_ONE_MINUS_DST_ALPHA:BlendSRC=9;break;
	}

	switch(VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst)
	{
	case  TX_BLEND_ZERO               :BlendDST=0;break;
	case  TX_BLEND_ONE                :BlendDST=1;break;
	case  TX_BLEND_SRC_COLOR          :BlendDST=2;break;
	case  TX_BLEND_ONE_MINUS_SRC_COLOR:BlendDST=3;break;
	case  TX_BLEND_DST_COLOR          :BlendDST=4;break;
	case  TX_BLEND_ONE_MINUS_DST_COLOR:BlendDST=5;break;
	case  TX_BLEND_SRC_ALPHA          :BlendDST=6;break;
	case  TX_BLEND_ONE_MINUS_SRC_ALPHA:BlendDST=7;break;
	case  TX_BLEND_DST_ALPHA          :BlendDST=8;break;
	case  TX_BLEND_ONE_MINUS_DST_ALPHA:BlendDST=9;break;
	}

	Blend = VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].Blend;

	EnableLev = VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].Visible;
	UpdateData(FALSE);
}


void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo6()
{
	UpdateData(TRUE);
	switch(EnvMode)
	{
	case 0:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].EnvMode = TX_MODE_ADD;     break;
	case 1:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].EnvMode = TX_MODE_MODULATE;break;
	case 2:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].EnvMode = TX_MODE_DECAL;   break;
	case 3:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].EnvMode = TX_MODE_BLEND;   break;
	case 4:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].EnvMode = TX_MODE_REPLACE; break;
	}


}

void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo7()
{
	UpdateData(TRUE);
	switch(BlendSRC)
	{
	case  0:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_ZERO;                    break;
	case  1:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_ONE;                     break;
	case  2:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_SRC_COLOR;               break;
	case  3:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_ONE_MINUS_SRC_COLOR;     break;
	case  4:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_DST_COLOR;               break;
	case  5:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_ONE_MINUS_DST_COLOR;     break;
	case  6:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_SRC_ALPHA;               break;
	case  7:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_ONE_MINUS_SRC_ALPHA;     break;
	case  8:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_DST_ALPHA;               break;
	case  9:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendSrc = TX_BLEND_ONE_MINUS_DST_ALPHA;     break;
	}
}

void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo8()
{
	UpdateData(TRUE);
	switch(BlendDST)
	{
	case  0:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_ZERO;                    break;
	case  1:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_ONE;                     break;
	case  2:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_SRC_COLOR;               break;
	case  3:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_ONE_MINUS_SRC_COLOR;     break;
	case  4:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_DST_COLOR;               break;
	case  5:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_ONE_MINUS_DST_COLOR;     break;
	case  6:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_SRC_ALPHA;               break;
	case  7:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_ONE_MINUS_SRC_ALPHA;     break;
	case  8:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_DST_ALPHA;               break;
	case  9:VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].BlendDst = TX_BLEND_ONE_MINUS_DST_ALPHA;     break;
	}
}


void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo9()
{
	UpdateData(TRUE);
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].Blend = Blend;
}


void CTEngineVRDemo1Dlg::OnBnClickedCheck1()
{
	UpdateData(TRUE);
	VR.SceneList[0].EnableBkgTexture = EnableBkgT;
}


void CTEngineVRDemo1Dlg::OnCbnSelchangeCombo10()
{
	UpdateData(TRUE);
	VR.SceneList[0].ObjectList[0].MaterialList[0].TextureLevelList[Level].Visible = EnableLev;
}


void CTEngineVRDemo1Dlg::OnBnClickedCheck2()
{
	UpdateData(TRUE);
}
