#pragma once
#include <gl/gl.h>
#include "TVector.h"
#include "TMatrix4x4.h"

#define SetColor(c,r,g,b,a)  c[0]=r,c[1]=g,c[2]=b,c[3]=a
//#define SetPosition(p,x,y,z) p[0]=x,p[1]=y,p[2]=z
//#define SetDirection(p,x,y,z) p[0]=x,p[1]=y,p[2]=z
class TLight
{
public:
	int   Enabled;
	int   Index;
	float Position[3];
	float Direction[3];
	float Ambient[4];
	float Diffuse[4];
	float Specular[4];
	float Cutoff;
	float SpotProfile;
	float ConstantAttenuation;
	float LinearAttenuation;
	float QuadraticAttenuation;
	TMatrix4x4 T; //Model View Matrix
	
	TLight(void);
	~TLight(void);
	void EnableLight(int enable);
	void SetAmbientColor(float r, float g, float b, float a);
	void BuildMatrix();
	void SetPosition(float x, float y, float z);
	void SetDirection(float x, float y, float z);
	void LookAt(float x, float y, float z);
	void LoadLight();
};

