#pragma once
#include <gl/gl.h>
#include "TVector.h"
#include "TMatrix4x4.h"


#define MAPPING_UV        0
#define MAPPING_SPHERE    1 
#define MAPPING_CUBE      2 


//ADD;MODULATE;DECAL;BLEND;REPLACE;COMBINE;
#define TX_MODE_ADD      GL_ADD
#define TX_MODE_MODULATE GL_MODULATE
#define TX_MODE_DECAL    GL_DECAL
#define TX_MODE_BLEND    GL_BLEND 
#define TX_MODE_REPLACE  GL_REPLACE
#define TX_MODE_COMBINE  GL_COMBINE

//REPLACE;MODULATE;ADD;ADD_SIGNED;INTERPOLATE;SUBTRACT;DOT3_RGB;DOT3_RGBA;
#define TX_RGB_REPLACE      GL_REPLACE
#define TX_RGB_MODULATE	    GL_MODULATE
#define TX_RGB_ADD	        GL_ADD
#define TX_RGB_ADD_SIGNED	GL_ADD_SIGNED
#define TX_RGB_INTERPOLATE	GL_INTERPOLATE
#define TX_RGB_SUBTRACT	    GL_SUBTRACT
#define TX_RGB_DOT3_RGB	    GL_DOT3_RGB
#define TX_RGB_DOT3_RGBA    GL_DOT3_RGBA

//REPLACE;MODULATE;ADD;ADD_SIGNED;INTERPOLATE;SUBTRACT;
#define TX_ALPHA_REPLACE     GL_REPLACE
#define TX_ALPHA_MODULATE    GL_MODULATE
#define TX_ALPHA_ADD         GL_ADD
#define TX_ALPHA_ADD_SIGNED  GL_ADD_SIGNED
#define TX_ALPHA_INTERPOLATE GL_INTERPOLATE
#define TX_ALPHA_SUBTRACT    GL_SUBTRACT

//ZERO;ONE;SRC_COLOR;ONE_MINUS_SRC_COLOR;DST_COLOR;ONE_MINUS_DST_COLOR;SRC_ALPHA;ONE_MINUS_SRC_ALPHA;DST_ALPHA;ONE_MINUS_DST_ALPHA;CONSTANT_COLOR;ONE_MINUS_CONSTANT_COLOR;CONSTANT_ALPHA;ONE_MINUS_CONSTANT_ALPHA;
#define TX_BLEND_ZERO                     GL_ZERO 
#define TX_BLEND_ONE                      GL_ONE 
#define TX_BLEND_SRC_COLOR                GL_SRC_COLOR
#define TX_BLEND_ONE_MINUS_SRC_COLOR      GL_ONE_MINUS_SRC_COLOR
#define TX_BLEND_DST_COLOR                GL_DST_COLOR
#define TX_BLEND_ONE_MINUS_DST_COLOR      GL_ONE_MINUS_DST_COLOR
#define TX_BLEND_SRC_ALPHA                GL_SRC_ALPHA
#define TX_BLEND_ONE_MINUS_SRC_ALPHA      GL_ONE_MINUS_SRC_ALPHA
#define TX_BLEND_DST_ALPHA                GL_DST_ALPHA
#define TX_BLEND_ONE_MINUS_DST_ALPHA      GL_ONE_MINUS_DST_ALPHA
#define TX_BLEND_CONSTANT_COLOR           GL_CONSTANT_COLOR
#define TX_BLEND_ONE_MINUS_CONSTANT_COLOR GL_ONE_MINUS_CONSTANT_COLOR
#define TX_BLEND_CONSTANT_ALPHA           GL_CONSTANT_ALPHA
#define TX_BLEND_ONE_MINUS_CONSTANT_ALPHA GL_ONE_MINUS_CONSTANT_ALPHA



typedef struct
{
  unsigned int TextureIndex;
  unsigned int EnvMode;
  unsigned int CombineRGB;
  unsigned int CombineAlpha;
  unsigned int MappingType;
  unsigned int Blend;
  unsigned int BlendSrc;
  unsigned int BlendDst;
  unsigned int Visible;
}TTextureLevel;

class TMaterial
{
public:
	float Ambient [4];
	float Specular[4];
	float Diffuse [4];
	float Emissive[4];
	float Color [4];
	float Shininess;
	short Smoothing;
	short Visible;
	short Doublesided;
	short Wireframe;
	TTextureLevel * TextureLevelList;
    unsigned int    TextureLevelListLen;

	TMaterial(void);
	~TMaterial(void);
	void LoadDefaultMaterial();
	void LoadMaterial();
	int  AddTextureLevel(unsigned int TexIndex, unsigned int Operation);
    int  RemoveTextureLevel(unsigned int Level);
 };

