#pragma once
#include <gl/gl.h>
#include "TVector.h"
#include "TMatrix4x4.h"
#include "TPolygon.h"
#include "TSurface.h"
#include "TTexture.h"
#include "TMaterial.h"


#define TO_MAXNAME_LEN 256

class TObject
{
public:
	TPose        Pose;        //Object Pose
	TVector      Scale;       //Object Scale
	TMatrix4x4   TRS;         //Model View Matrix

	TSurface     * SurfaceList;     //Surfaces of the Object
	unsigned int   SurfaceListLen;    //Number of Surfaces

	TTexture     * TextureList;
	unsigned int   TextureListLen;

	TMaterial    * MaterialList;     //Materials
	unsigned int   MaterialListLen;    //Number of Materials

	TBoundingBox   BBox;
	
	int            Visible;     //Visibility Flag
	char           FileName[TO_MAXNAME_LEN];
	TObject(void);
	~TObject(void);
	
	void BuildNormals();               //calculate Normal
	void BuildMatrix();                //Builds the TRS Matrix
	void Draw();                       //draw

	void CreateSampleCube();
	void CreateObject(unsigned int Surfaces, unsigned int Materials);
	int  Load3DSObject(char * filename); //Load 3DStudio File format
	int  LoadOBJObject(char * filename);
	void DestroyObject();

	int AddTexture(char * filename, int Interpolation);
    int DeleteTexture(unsigned int Index);
};

