#include "StdAfx.h"
#include "TPolygon.h"


void TPolygon::BuildNormal()
{
	TVector V1,V2;
	V1.vector(VertexList[v1].x-VertexList[v0].x, VertexList[v1].y-VertexList[v0].y, VertexList[v1].z-VertexList[v0].z);
	V2.vector(VertexList[v2].x-VertexList[v0].x, VertexList[v2].y-VertexList[v0].y, VertexList[v2].z-VertexList[v0].z);
	Normal = V1^V2;
	Normal.Normalize();
}

void TPolygon::Flip()
{
	float a = v1; v1=v2; v2=a;
}

void TPolygon::DrawTexture()
{
	if(Visible)
	{
		if(MaterialList[Material].Smoothing)
		{
			glBegin(GL_TRIANGLES);
				glNormal3f(NormalList[v0].x, NormalList[v0].y, NormalList[v0].z); glTexCoord2f(TexCoordList[t0].u, TexCoordList[t0].v); glVertex3f(VertexList[v0].x, VertexList[v0].y, VertexList[v0].z);
				glNormal3f(NormalList[v1].x, NormalList[v1].y, NormalList[v1].z); glTexCoord2f(TexCoordList[t1].u, TexCoordList[t1].v); glVertex3f(VertexList[v1].x, VertexList[v1].y, VertexList[v1].z);
				glNormal3f(NormalList[v2].x, NormalList[v2].y, NormalList[v2].z); glTexCoord2f(TexCoordList[t2].u, TexCoordList[t2].v); glVertex3f(VertexList[v2].x, VertexList[v2].y, VertexList[v2].z);
			glEnd();
		}
		else
		{
			glBegin(GL_TRIANGLES);
				glNormal3f(Normal.x, Normal.y, Normal.z); 
				glTexCoord2f(TexCoordList[t0].u, TexCoordList[t0].v);glVertex3f(VertexList[v0].x, VertexList[v0].y, VertexList[v0].z);
				glTexCoord2f(TexCoordList[t1].u, TexCoordList[t1].v);glVertex3f(VertexList[v1].x, VertexList[v1].y, VertexList[v1].z);
				glTexCoord2f(TexCoordList[t2].u, TexCoordList[t2].v);glVertex3f(VertexList[v2].x, VertexList[v2].y, VertexList[v2].z);
			glEnd();
		}
	}
}

void TPolygon::Draw()
{
	int i;
	if(Visible)
	{
		if(MaterialList[Material].Smoothing)
		{
			glBegin(GL_TRIANGLES);
				glNormal3f(NormalList[v0].x, NormalList[v0].y, NormalList[v0].z); glVertex3f(VertexList[v0].x, VertexList[v0].y, VertexList[v0].z);
				glNormal3f(NormalList[v1].x, NormalList[v1].y, NormalList[v1].z); glVertex3f(VertexList[v1].x, VertexList[v1].y, VertexList[v1].z);
				glNormal3f(NormalList[v2].x, NormalList[v2].y, NormalList[v2].z); glVertex3f(VertexList[v2].x, VertexList[v2].y, VertexList[v2].z);
			glEnd();
		}
		else
		{
			glBegin(GL_TRIANGLES);
				glNormal3f(Normal.x, Normal.y, Normal.z); 
				glVertex3f(VertexList[v0].x, VertexList[v0].y, VertexList[v0].z);
				glVertex3f(VertexList[v1].x, VertexList[v1].y, VertexList[v1].z);
				glVertex3f(VertexList[v2].x, VertexList[v2].y, VertexList[v2].z);
			glEnd();
		}
	}
}

void TPolygon::DrawNormal()
{
	if(Visible)
	{
		glDisable(GL_LIGHTING);
		glEnable (GL_COLOR_MATERIAL);
		glColor4f(1.0f,1.0f,0.0f,1.0f);
	    glBegin(GL_LINE_STRIP);
		  glVertex3f(VertexList[v0].x, VertexList[v0].y, VertexList[v0].z);
		  glVertex3f(VertexList[v1].x, VertexList[v1].y, VertexList[v1].z);
		  glVertex3f(VertexList[v2].x, VertexList[v2].y, VertexList[v2].z);
		  glVertex3f(VertexList[v0].x, VertexList[v0].y, VertexList[v0].z);
		glEnd();
		TVertex s;
		s.x=(VertexList[v0].x+VertexList[v1].x+VertexList[v2].x)*0.33333333f;
		s.y=(VertexList[v0].y+VertexList[v1].y+VertexList[v2].y)*0.33333333f;
		s.z=(VertexList[v0].z+VertexList[v1].z+VertexList[v2].z)*0.33333333f;
	    glBegin(GL_LINE_STRIP);
		  glVertex3f(s.x, s.y, s.z);
		  glVertex3f(s.x+Normal.x, s.y+Normal.y, s.z+Normal.z); 
		glEnd();

	}
}

void TPolygon::Triangle(unsigned int vt0, unsigned int vt1, unsigned int vt2)
{
	v0 = vt0;
	v1 = vt1;
	v2 = vt2;
}