#pragma once

#include <gl/gl.h>
#include "TVector.h"
#include "TMaterial.h"
#include "TTexture.h"

typedef struct{ float u,v; }TTexCoord;

class TPolygon
{
public:
	unsigned int v0,v1,v2;
	unsigned int t0,t1,t2;
	int Visible;
	TVector Normal;
	
	TVertex      * VertexList;
	TVector      * NormalList;
	TTexCoord    * TexCoordList;
	TTexture     * TextureList;
	TMaterial    * MaterialList;
	unsigned int   Material;
	
	TPolygon(void) {v0=v1=v2=-1;t0=t1=t2=-1; VertexList = NormalList = NULL; Visible = 1;}
	~TPolygon(void){}

	void Triangle(unsigned int vt0, unsigned int vt1, unsigned int vt2);
	void BuildNormal();
	void Flip();
	void Draw();
	void DrawTexture();
	void DrawNormal();
};

