#pragma once
#include <gl/gl.h>
#include "TCamera.h"
#include "TObject.h"
#include "TLight.h"

typedef struct
{
	float r,g,b,a;
}TColor;

class TScene
{
public:

	TCamera      * CameraList;
	unsigned int   CameraListLen;
	unsigned int   SelectedCamera;

    TObject      * ObjectList; //List of objects
	unsigned int ObjectListLen; //Number of objects
	
	TLight       * LightList;
	unsigned int   LightListLen;
	int Visible;  //Visibility Flag
	TColor ClearColor;

	unsigned int EnableBkgTexture;
	TTexture Background;

	TScene(void);
	~TScene(void);
	void BuildSceneGeometry();         //Initialize Scene Geometry
	void BuildSceneMatrices();//builds the scene matrices
	void Draw();              //draw scene
    void DrawBackground();
	void SetClearColor(float r, float g, float b, float a);
	int  LoadScene(char * filename);
	int  SaveScene(char * filename);
	void CreateScene(unsigned int Cameras, unsigned int Lights, unsigned int Objects);
	void DestroyScene();
};

