#pragma once

#include <gl/gl.h>
#include "TVector.h"
#include "TPolygon.h"
#include "TMaterial.h"

typedef struct
{
	TVertex Min,Max;
}TBoundingBox;


class TSurface
{
public:
	TSurface(void);
	~TSurface(void){}

	TVertex      * VertexList;  //Vertices on the surface
	TVertex      * NormalList;  //Normals on the surface
    unsigned int   VNListLen;   //Number of Vertices

	TTexCoord    * TexCoordList;
	unsigned int   TexCoordListLen;
    
	TPolygon     * PolygonList;  //Polygons on the surface
    unsigned int   PolygonListLen; //Number of Polygons on the surface
    
 	TMaterial    * MaterialList;
	unsigned int   Material;

	TTexture     * TextureList;

	TBoundingBox   BBox;
    int  Visible;          //Visibility Flag

	int  CreateSurface(unsigned int Vertices, unsigned int TexCoords, unsigned int Polygons, unsigned int MatIndex);
	int  CreateSurface(TVertex * v, unsigned int Vertices, TPolygon * p, unsigned int Polygons, unsigned int MatIndex);
    void DestroySurface();
	
	void BuildNormals();   //calculate Normal
    void Flip();           //flip the normal orientation
    void Draw();           //draw

};

