#include "StdAfx.h"
#include "TTexture.h"


TTexture::TTexture(void)
{
	strcpy(Name,"No Name");
    Width         = 0;
    Height        = 0;
    Texture       = -1; 
    Interpolation = TXLINEAR;
    CromaKey      = 0;
	KeyColor.r    = 0;
	KeyColor.g    = 0;
	KeyColor.b    = 0;
	KeyColor.a    = 0;
}


TTexture::~TTexture(void)
{
}


int TTexture::LoadBMPTexture(char * filename, 
                   int InterpolationMode)
{
	FILE * fp;
  if(fp=fopen(filename,"r"))
  {
     fclose(fp);
     AUX_RGBImageRec * TextureImage=NULL;
     RGBA8 * pData;
     RGB8  * pDatargb;
     Interpolation = InterpolationMode;
     if(TextureImage=auxDIBImageLoad(filename))
     {
       int imageSize = TextureImage->sizeX * TextureImage->sizeY;
       pDatargb      = (RGB8 *)TextureImage->data;
       pData         = new RGBA8[TextureImage->sizeX * TextureImage->sizeY];
       unsigned int i;
       for(i=0;i<imageSize;i++)
       {
          pData[i].r=pDatargb[i].r;
          pData[i].g=pDatargb[i].g;
          pData[i].b=pDatargb[i].b;
          pData[i].a=(float)(pData[i].r+pData[i].g+pData[i].b)*0.333333333333333333333333334f;
          if( pData[i].r == KeyColor.r &&
			  pData[i].g == KeyColor.g &&
			  pData[i].b == KeyColor.b)
		  {
			  pData[i].a = 0; 
		  }
       }
       Width  = TextureImage->sizeX;
       Height = TextureImage->sizeY;
       BuildTexture(pData);
       if(TextureImage)
       {
         if(TextureImage->data) delete TextureImage->data;
         delete TextureImage;
       }
       if(pData) delete pData;
       return TRUE;  
      }
    }
    return FALSE;
}

int TTexture::BuildTexture(RGBA8 * TxData)
{
   if(!TxData) return 0;
   glPixelTransferf(GL_RED_SCALE  ,1.0f);
   glPixelTransferf(GL_GREEN_SCALE,1.0f);
   glPixelTransferf(GL_BLUE_SCALE ,1.0f);
 
   glTexParameteri (GL_TEXTURE_2D,GL_TEXTURE_WRAP_S ,GL_REPEAT );
   glTexParameteri (GL_TEXTURE_2D,GL_TEXTURE_WRAP_T ,GL_REPEAT ); 

   glGenTextures(1,&Texture);
   glBindTexture(GL_TEXTURE_2D,Texture);

   switch(Interpolation)
   {
    case TXNEAREST :glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
                    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	                glTexImage2D   (GL_TEXTURE_2D,0,GL_RGBA,Width,Height,0,GL_RGBA,GL_UNSIGNED_BYTE,TxData);
	                break;
    case TXLINEAR  :glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	                glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	                glTexImage2D   (GL_TEXTURE_2D,0,GL_RGBA,Width,Height,0,GL_RGBA,GL_UNSIGNED_BYTE,TxData);
	                break;

    case TXMIPMAP  :glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	                glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	                gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA,Width,Height,GL_RGBA,GL_UNSIGNED_BYTE,TxData);
	                break;
    }
   return 1;
}