#include "StdAfx.h"
#include "TVector.h"

int TVector::operator ==  (TVector &v)
{
	if(v.x==x && v.y==y && v.z==z) return 1;
	return 0;
}

int TVector::operator !=  (TVector &v)
{
	if(v.x!=x ||v.y!=y ||v.z!=z) return 1;
	return 0;
}

TVector TVector::operator +  (TVector &v)
{
	TVector t;
	t.x=v.x+x;
	t.y=v.y+y;
	t.z=v.z+z;
	return t;
}
TVector TVector::operator - (TVector &v)
{
    TVector t;
	t.x=x-v.x;
	t.y=y-v.y;
	t.z=z-v.z;
	return t;
}

float TVector::operator * (TVector &v)
{
	return v.x*x+v.y*y+v.z*z;
}

TVector TVector::operator ^ (TVector &v)
{
	TVector t;
	t.x=(y*v.z-z*v.y);
	t.y=(z*v.x-x*v.z);
	t.z=(x*v.y-y*v.x);
	return t;
}

TVector TVector::operator / (TVector &v)
{
	TVector t;
	t.x=x/v.x;
	t.y=y/v.y;
	t.z=z/v.z;
	return t;
}
TVector &TVector::operator -= (TVector &v)
{
	x-=v.x;
	y-=v.y;
	z-=v.z;
	return *this;
}


TVector &TVector::operator += (TVector &v)
{
    x+=v.x;
	y+=v.y;
	z+=v.z;
	return *this;
}

TVector &TVector::operator *= (TVector &v)
{
    x*=v.x;
	y*=v.y;
	z*=v.z;
	return *this;
}

TVector TVector::operator - (float &v)
{
    TVector t;
	t.x=x-v;
	t.y=y-v;
	t.z=z-v;
	return t;
}
TVector TVector::operator + (float &v)
{
	TVector t;
	t.x=x+v;
	t.y=y+v;
	t.z=z+v;
	return t;
}
TVector TVector::operator * (float &v)
{
	TVector t;
	t.x=x*v;
	t.y=y*v;
	t.z=z*v;
	return t;
}
TVector TVector::operator / (float &v)
{
	TVector t;
	float V=1.0f/v;
	t.x=x*V;
	t.y=y*V;
	t.z=z*V;
	return t;
}
TVector &TVector::operator -= (float &v)
{
	
	x-=v;
	y-=v;
	z-=v;
	return *this;
}
TVector &TVector::operator += (float &v)
{
	x+=v;
	y+=v;
	z+=v;
	return *this;
}
TVector &TVector::operator *= (float &v)
{
	x*=v;
	y*=v;
	z*=v;
	return *this;
}

TVector &TVector::operator /= (float &v)
{
	float V=1.0f/v;
	x*=V;
	y*=V;
	z*=V;
	return *this;
}
void TVector::Normalize()
{
	
	float mod=(float)sqrt((float)x*x+y*y+z*z);
	if(mod!=0.0f)
	{ 
	  mod = 1.0f/mod;
	  x=(float)x*mod;
	  y=(float)y*mod;
	  z=(float)z*mod;
	}
	
}

void TVector::Normalize(float MaxModule)
{
	
	float mod=MaxModule;
	if(mod!=0.0f)
	{ 
	  mod = 1.0f/mod;
	  x=(float)x*mod;
	  y=(float)y*mod;
	  z=(float)z*mod;
	}
	
}

void TVector::Clear() {x=y=z=0.0f;}

void TVector::vector(float xx,float yy,float zz)
{
	x=xx;
	y=yy;
	z=zz;
}

float TVector::Module()
{
	return (float) sqrt((float)x*x+y*y+z*z);
}

void TVector::Scale(float s)
{
	x*=s;
	y*=s;
	z*=s;
}

void TVector::Reflect(TVector n)
{
	TVector t =  * this;
	n.Scale(2.0f*(t*n));
    *this = t-n;
}

void TVector::Refract(TVector n, float RefIndex)
{
   n.Scale(-RefIndex);
   TVector t =  *this;
   t.Scale(1.0f-RefIndex);
   *this = t+n;
}