#pragma once
//#ifndef __TVECTOR_H
//#define __TVECTOR_H
#include <math.h>

#define PI  3.1415926535897932384626433832795
#define D2R 0.0174532925199432957692369076848
#define R2D 57.295779513082320876798154817014
#define B2F 0.00392156862f  //0-255 -> 0-1.0

class TVector
{
public:
	float x,y,z;
	TVector(void)  {x=y=z=0.0f;}
	~TVector(void) {}
	int operator ==  (TVector &v);
	int operator !=  (TVector &v);

	TVector operator -  (TVector &v);
	TVector operator +  (TVector &v);
	float  operator *  (TVector &v);
	TVector operator ^  (TVector &v);
	TVector operator /  (TVector &v);

	TVector &operator -=  (TVector &v);
	TVector &operator +=  (TVector &v);
	TVector &operator *=  (TVector &v);

	TVector operator -  (float &v);
	TVector operator +  (float &v);
	TVector operator *  (float &v);
	TVector operator /  (float &v);

	TVector &operator -=  (float &v);
	TVector &operator +=  (float &v);
	TVector &operator *=  (float &v);
	TVector &operator /=  (float &v);
	
	void Clear();
	void vector(float xx,float yy,float zz);
	float Module();

	void Normalize();
	void Normalize(float MaxModule);
	void Scale(float s);

	void Reflect(TVector n);
	void Refract(TVector n, float RefIndex);
};

typedef TVector TVertex;

class TPose:public TVector
{
public:
	float roll, pitch, yaw;
	TPose() {x=y=z=roll=pitch=yaw=0;}
	void SetPose(float px, float py, float pz, float proll, float ppitch, float pyaw) {x=px;y=py;z=pz;roll=proll;pitch=ppitch;yaw=pyaw;}
};